<script lang="ts">
	import { categories } from "@/lib/stores";
	import type { Transaction } from "@/utils/types";
	import { Button, H2, H3, Label } from "attractions";
	import type { DialogProps } from "attractions/dialog/dialog.svelte";
	import Dialog from "attractions/dialog/dialog.svelte";
	import moment from "moment";
	import { createEventDispatcher } from "svelte";

	export let closeCallback: DialogProps["closeCallback"];
	export let transaction: Transaction | undefined;

	$: category = $categories.find((c) => c.id === transaction?.category);

	let dispatch = createEventDispatcher<{ edit_category: Transaction }>();
</script>

<div class="dialog-wrapper">
	<Dialog {closeCallback} title="Tranzakció részletei">
		<div class="dialog-content">
			<div class="edit">
				<Button round neutral on:click={() => dispatch("edit_category", transaction)}>
					<i class="material-icons">edit</i>
				</Button>
			</div>
			<div class="category">
				<img
					src={`data:image/jpeg;base64,${category?.icon}`}
					alt={category?.name}
					class="icon"
				/>
				<Label>{category?.name}</Label>
			</div>
			<H3>{transaction?.partner_account_name}</H3>
			<Label>{transaction?.partner_account_number}</Label>

			<div class="amount">
				<H2>{transaction?.amount} Ft</H2>
			</div>
			<div class={`${transaction?.successful ? "success" : "error"}`}>
				<i class="material-icons tick-icon">{transaction?.successful ? "check" : "close"}</i>
				{transaction?.successful ? "Sikeres" : "Sikertelen"}
			</div>
			<div class="date">
				<Label>Tranzakció időpontja</Label>
				<Label small>{moment(transaction?.date).format("YYYY.MM.DD hh:mm:ss")}</Label>
			</div>
			<div class="message">
				<Label>Közlemény</Label>
				<Label small>{transaction?.message}</Label>
			</div>
			<Label small>Azonosító: {transaction?.id}</Label>
		</div>
	</Dialog>
</div>

<style>
	div {
		text-align: center;
	}
	.dialog-wrapper {
		width: 450px;
	}
	.dialog-content {
		display: flex;
		flex-direction: column;
		align-items: center;
	}
	.edit {
		position: absolute;
		left: calc(50% + 40px);
	}
	.category {
		padding-bottom: 12px;
	}
	.icon {
		width: 50px;
	}
	.amount {
		padding: 36px 0;
	}
	.success,
	.error {
		display: flex;
		align-items: center;
		padding-bottom: 8px;
		text-transform: uppercase;
		font-size: 9pt;
	}
	.success {
		color: green;
	}
	.error {
		color: red;
	}
	.tick-icon {
		margin-right: 6px;
	}
	.date {
		padding-bottom: 12px;
	}
	.message {
		padding-bottom: 12px;
	}
</style>
